import math
from cs116 import *
from backend.simplesound import SimpleSound
from backend.color import Color


class Sound(SimpleSound):
    #normalize a sound to maximum possible volume
    # subgoal 1: accumulate the maximum sound sample
    # subgoal 2: change the volume using 32767 / max as the factor of change.
    def normalize(self):
        # accumulate the maximum sound sample value
        max = 0
        for s in self.getSamples():
            if s.getValue() > max:
                max = s.getValue()
        # change the volume to maximum possible
        for s in self.getSamples():
            value = s.getValue()
            s.setValue(value * 32767.0 / max)
            
    def silenceStartingAt(self, offset, length):
        samples = self.getSamples()
        for index in range(0, length):
            samples[offset+index].setValue(0)
            
    def reverse(self):
        result = Sound(self.getLength())
        samples1 = self.getSamples()
        samples2 = result.getSamples()
        length = self.getLength()
        for i in range(0,length):
            samples2[length-i-1].setValue(samples1[i].getValue())
        return result
    
    def raisePitch(self):
        result = Sound(self.getLength()//2)
        samples1 = self.getSamples()
        samples2 = result.getSamples()
        for i in range(0,len(samples1)):
            if i%2 == 0:
                samples2[i//2].setValue(samples1[i].getValue())
        return result
    